"use strict";

var _interopRequire = function (obj) { return obj && obj.__esModule ? obj["default"] : obj; };

exports.check = check;
exports.Property = Property;

var ReplaceSupers = _interopRequire(require("../../helpers/replace-supers"));

var t = _interopRequire(require("../../../types"));

function check(node) {
  return t.isIdentifier(node, { name: "super" });
}

function Property(node, parent, scope, file) {
  if (!node.method) return;

  var value = node.value;
  var thisExpr = scope.generateUidIdentifier("this");

  var replaceSupers = new ReplaceSupers({
    topLevelThisReference: thisExpr,
    methodNode: node,
    className: thisExpr,
    isStatic: true,
    scope: scope,
    file: file
  });

  replaceSupers.replace();

  if (replaceSupers.hasSuper) {
    value.body.body.unshift(t.variableDeclaration("var", [t.variableDeclarator(thisExpr, t.thisExpression())]));
  }
}

exports.__esModule = true;