"use strict";

var _interopRequire = function (obj) { return obj && obj.__esModule ? obj["default"] : obj; };

var _interopRequireWildcard = function (obj) { return obj && obj.__esModule ? obj : { "default": obj }; };

var messages = _interopRequireWildcard(require("../../../messages"));

var build = _interopRequire(require("../../helpers/build-conditional-assignment-operator-transformer"));

var t = _interopRequire(require("../../../types"));

var playground = exports.playground = true;

build(exports, {
  is: (function (_is) {
    var _isWrapper = function is(_x, _x2) {
      return _is.apply(this, arguments);
    };

    _isWrapper.toString = function () {
      return _is.toString();
    };

    return _isWrapper;
  })(function (node, file) {
    var is = t.isAssignmentExpression(node) && node.operator === "||=";
    if (is) {
      var left = node.left;
      if (!t.isMemberExpression(left) && !t.isIdentifier(left)) {
        throw file.errorWithNode(left, messages.get("expectedMemberExpressionOrIdentifier"));
      }
      return true;
    }
  }),

  build: function build(node) {
    return t.unaryExpression("!", node, true);
  }
});
exports.__esModule = true;